#include<iostream>
#include<algorithm>
#include<vector>
#include<cstring>
using namespace std;
int n, a, b;

struct pl
{
    int startm;
    int endm;
    long long price;

    bool operator < (pl A) const
    {
        if(startm > A.startm){
            return false;
        }
        if(startm < A.startm){
            return true;
        }
        if(endm < A.endm){
            return true;
        }
        if(endm > A.endm){
            return false;
        }
        if(price < A.price){
            return true;
        }else{
            return false;
        }
    }

};

vector<pl> plan;

long long dp[1048576];

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    cin >> a >> b;
    pl nesh;
    for(int i = 0; i < n; i++){
        cin >> nesh.startm >> nesh.endm >> nesh.price;
        plan.push_back(nesh);
    }
    sort(plan.begin(), plan.end());
    memset(dp, -1, sizeof(dp));
    for(int i = 0; i < a; i++){
        dp[i] = 0;
    }
    for(int i = 0; i <= n; i++){
        int s, e, c;
        s = plan[i].startm;
        e = plan[i].endm;
        c = plan[i].price;
        for(int j = s; j <= e; j++){
            if(dp[s-1] != -1 && (dp[j] > dp[s-1]+c || dp[j] == -1)){
                dp[j] = dp[s-1]+c;
            }

        }
    }
    if(dp[n] == -1){
        cout << "Impossible\n";
        return 0;
    }
    cout << dp[b] << endl;
return 0;
}
/*
5
5 15
11 15 8
1 6 23
6 12 13
7 16 35
3 5 10
*/
