#include<iostream>
#include<algorithm>
#include<vector>
#include<cstring>
using namespace std;
int n, a, b, t, startind;
bool used[10048576];
vector<int> times;

struct pl
{
    int startm;
    int endm;
    long long price;

    bool operator < (pl A) const
    {
        if(startm > A.startm){
            return false;
        }
        if(startm < A.startm){
            return true;
        }
        if(endm < A.endm){
            return true;
        }
        if(endm > A.endm){
            return false;
        }
        if(price < A.price){
            return true;
        }else{
            return false;
        }
    }

};

vector<pl> plan;

long long dp[10048576];

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    cin >> a >> b;
    pl nesh;
    for(int i = 0; i < n; i++){
        cin >> nesh.startm >> nesh.endm >> nesh.price;
        if(!used[nesh.startm]){
            used[nesh.startm] = true;
            times.push_back(nesh.startm - 1);
        }
        plan.push_back(nesh);
    }
    times.push_back(b);
    times.push_back(a);
    sort(plan.begin(), plan.end());
    sort(times.begin(), times.end());
    memset(dp, -1, sizeof(dp));
    for(int i = 0; i < a; i++){
        dp[i] = 0;
    }
    for(int i = 0; i <= n; i++){
        int s, e, c;
        s = plan[i].startm;
        e = plan[i].endm;
        c = plan[i].price;
        for(int j = startind; j < times.size(); j++){
            t = times[j];
            if(t >= s && t <= e && (dp[s-1] != -1 && (dp[t] > dp[s-1]+c || dp[t] == -1))){
                dp[t] = dp[s-1]+c;
            }
            if(t > e){
                break;
            }
            if(t < s){
                startind++;
            }
        }
    }
    if(dp[b] == -1){
        cout << "Impossible\n";
        return 0;
    }
    cout << dp[b] << endl;
return 0;
}
/*
5
5 15
11 15 8
1 6 23
6 12 13
7 16 35
3 5 10
*/
