#include <bits/stdc++.h>
using namespace std;
#define sz(x) (int)x.size()
#define pb(x) push_back(x)
#define print(x) cout << #x << " = " << x << "\n";

const int MAX_N = 1010, MAX_M = 4200;
int type[MAX_N];
int ans;
int n;
bool minavano[MAX_N][MAX_M];

int onbits(int x) {
    int ret = 0;
    for(int i = 0; i < 12; i ++) {
        if(x & (1 << i)) {
            ret ++;
        }
    }
    return ret;
}

void rec(int q, int mask) {
    minavano[q][mask] = true;
    if(q == 0) {
        int currsz = onbits(mask);
        ans = max(currsz, ans);
        return;
    }
    for(int i = 0; i < n; i ++) {
        if(mask | type[i] != mask && !minavano[q - 1][mask | type[i]]) {
            rec(q - 1, mask | type[i]);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int k, t;
    cin >> n >> k >> t;
    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < t; j ++) {
            bool b;
            cin >> b;
            if(b) {
                type[i] = type[i] | (1 << j);
            }
        }
    }
    rec(k, 0);
    cout << ans;
    return 0;
}
/*
3 2 3
0 1 0
0 1 0
0 0 1
*/

/*
6 2 8
0 0 0 1 1 0 0 0
0 0 1 0 0 1 0 0
0 1 0 0 0 0 1 0
1 0 0 0 0 0 0 1
0 0 0 0 0 0 0 0
0 0 0 0 1 0 0 0
*/
