#include <bits/stdc++.h>
using namespace std;
#define sz(x) (int)x.size()
#define pb(x) push_back(x)
#define print(x) cout << #x << " = " << x << "\n";

const int MAX_N = 5e5 + 10;
long long ans[MAX_N];
struct Plan {
    int a, b, c, ind;
    bool operator <(Plan &other) {
        if(a == other.a) {
            if(b == other.b) {
                return c < other.c;
            }
            return b < other.b;
        }
        return a < other.a;
    }
};
Plan plan[MAX_N];
long long a, b;
long long n;

long long dij() {
    fill_n(ans, n, -1);
    long long ret = 1e7 + 10;
    priority_queue<pair<long long, int> > pq;
    for(int i = 0; i < n; i ++) {
        if(plan[i].a > a) {
            break;
        }
        if(plan[i].b < a) {
            continue;
        }
        pq.push({0, i});
        ans[i] = 0;
    }
    while(!pq.empty()) {
        pair<long long, int> curr = pq.top(); pq.pop();
        //cout << curr.second << " " << curr.first << endl;
        for(int i = curr.second; i < n; i ++) {
            if(plan[curr.second].a < plan[i].a && plan[i].a <= plan[curr.second].b + 1 && plan[i].b > plan[curr.second].b) {
                if(ans[i] == -1) {
                    pq.push({curr.first - plan[curr.second].c, i});
                    ans[i] = -(curr.first - plan[curr.second].c);
                }
            }
        }
    }
    for(int i = 0; i < n; i ++) {
        if(plan[i].b >= b) {
            ret = min(ret, ans[i] + plan[i].c);
        }
    }
    return ret;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n;
    cin >> a >> b;
    for(int i = 0; i < n; i ++) {
        cin >> plan[i].a >> plan[i].b >> plan[i].c;
    }
    sort(plan, plan + n);
    for(int i = 0; i < n; i ++) {
        plan[i].ind = i;
    }
    cout << dij();
    return 0;
}

/*
5
5 15
11 15 8
1 6 23
6 12 13
7 16 35
3 5 10
*/
