#include <bits/stdc++.h>
using namespace std;
#define sz(x) (int)x.size()
#define pb(x) push_back(x)
#define print(x) cout << #x << " = " << x << "\n";

const int MAX_N = 5e5 + 10, MAX_M = 1e7 + 10;
long long dp[MAX_N];
struct Plan {
    int a, b, c, ind;
    bool operator <(Plan &other) {
        if(a == other.a) {
            if(b == other.b) {
                return c < other.c;
            }
            return b < other.b;
        }
        return a < other.a;
    }
};
Plan plan[MAX_N];
long long a, b;
long long n;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n;
    cin >> a >> b;
    for(int i = 0; i < n; i ++) {
        cin >> plan[i].a >> plan[i].b >> plan[i].c;
    }
    sort(plan, plan + n);
    fill_n(dp, n, MAX_M);
    deque<Plan> d;
    for(int i = 0; i < n; i ++) {
        if(plan[i].a <= a && plan[i].b >= a) {
            dp[i] = plan[i].c;
            while(!d.empty() && d.back().c > dp[i]) {
                //cout << "Na ind " << i << " " << dp[i] << " Izbuta " << d.back().c << endl;
                d.pop_back();
            }
            d.push_back({plan[i].a, plan[i].b, dp[i]});
        } else if(plan[i].a >= a) {
            while(d.back().c > dp[i]) {
                d.pop_back();
            }
            dp[i] = d.front().c + plan[i].c;
            while(!d.empty() && d.front().b < plan[i].a) {
                //cout << "Na ind " << i << " " << dp[i] << " Izbuta " << d.back().c << endl;
                d.pop_front();
            }
            d.push_back({plan[i].a, plan[i].b, dp[i]});
        }
    }
    long long ans = MAX_M;
    for(int i = 0; i < n; i ++) {
//        cout << dp[i] << " ";
        if(plan[i].b >= b) {
            ans = min(ans, dp[i]);
        }
    }
    if(ans == MAX_M) {
        cout << "Impossible";
    } else {
        cout << ans;
    }
    return 0;
}
