#include <bits/stdc++.h>
using namespace std;
#define sz(x) (int)x.size()
#define pb(x) push_back(x)
#define print(x) cout << #x << " = " << x << "\n";

const int MAX_N = 5e5 + 10, MAX_M = 1e7 + 10;
long long dp[MAX_N];
struct Plan {
    int a, b, c, ind;
    bool operator <(Plan &other) {
        if(a == other.a) {
            if(b == other.b) {
                return c < other.c;
            }
            return b < other.b;
        }
        return a < other.a;
    }
};
Plan plan[MAX_N];
long long a, b;
long long n;

struct cmp {
    bool operator () (Plan a, Plan b) {
        return a.c > b.c;
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n;
    cin >> a >> b;
    for(int i = 0; i < n; i ++) {
        cin >> plan[i].a >> plan[i].b >> plan[i].c;
    }
    sort(plan, plan + n);
    fill_n(dp, n, MAX_M);
    priority_queue<Plan, vector<Plan>, cmp> pr;
    pr.push({0, a - 1, 0});
    for(int i = 0; i < n; i ++) {
        while(!pr.empty() && pr.top().b < plan[i].a - 1) {
            pr.pop();
        }
        if(!pr.empty()) {
            //cout << pr.top().a << " " << pr.top().b << " " << pr.top().c << endl;
            dp[i] = pr.top().c + plan[i].c;
            pr.push({plan[i].a, plan[i].b, dp[i]});
        }
    }
    long long ans = MAX_M;
    for(int i = 0; i < n; i ++) {
        //cout << dp[i] << " ";
        if(plan[i].b >= b) {
            ans = min(ans, dp[i]);
        }
    }
    if(ans == MAX_M) {
        cout << "Impossible";
    } else {
        cout << ans;
    }
    return 0;
}
