#include <iostream>
#include <algorithm>

const int MAX_N = 1024;

bool is[MAX_N][MAX_N], is2[MAX_N][MAX_N];
bool curr[MAX_N];

int st[MAX_N];
int indexes[MAX_N];
int razl[MAX_N];

bool cmp (int a, int b)
{
    return st[a] > st[b];
}

int main ()
{
    std::cin.tie(NULL);
    std::ios_base::sync_with_stdio(false);

    int n, k, t;
    std::cin >> n >> k >> t;

    for (int i = 0; i < n; ++ i)
    {
        indexes[i] = i;
        for (int j = 0; j < t; ++ j)
        {
            std::cin >> is[i][j];
            st[i] += is[i][j];
        }
    }

    std::sort(indexes, indexes + n, cmp);
    /*for (int i = 0; i < n; ++ i)
    {
        std::cout << indexes[i] << ' ';
    }
    std::cout << '\n';*/
    for (int i = 0; i < n; ++ i)
    {
        for (int j = 0; j < t; ++ j)
        {
            is2[i][j] = is[indexes[i]][j];
            //std::cout << is2[i][j];
        }
        //std::cout << '\n';
    }

    int prevst = 0, nextst;
    for (int i = 0; i < n; ++ i)
    {
        nextst = 0;
        for (int j = 0; j < t; ++ j)
        {
            curr[j] |= is2[i][j];
            nextst += curr[j];
        }
        razl[i] = nextst - prevst;
        prevst = nextst;
    }

    std::sort(razl, razl + n);

    for(int i = 0; i < n - k; ++ i)
    {
        nextst -= razl[i];
    }

    std::cout << nextst << '\n';

    return 0;
}
/*
3 1 8
0 1 0 0 0 0 0 0
0 1 0 1 0 1 0 1
0 1 1 0 1 0 0 0

6 2 8
0 0 0 1 1 0 0 0
0 0 1 0 0 1 0 0
0 1 0 0 0 0 1 0
1 0 0 0 0 0 0 1
0 0 0 0 0 0 0 0
0 0 0 0 1 0 0 0

3 2 3
0 1 0
0 1 0
0 0 1
*/
