#include <bits/stdc++.h>
#define endl '\n'
#define pb push_back
#define ll long long
#define ull unsigned long long
using namespace std;
const int MAX_N = 5e5+200;
const int MAX_M = 1e7+200;
const ull inf = 1e18;
struct plan{
    int S;
    int E;
    int C;
};
bool comp(plan a, plan b) {
    return b.E>a.E;
}
ull minimum[4*MAX_M];
int N;
int A, B;
plan pl[MAX_N];
int getLeaf(int ind) {
    return (ind+2*MAX_M);
}

void update (int ind, ull delta) {
    ind = getLeaf(ind);
    if(minimum[ind]<=delta)
        return;
    minimum[ind] = delta;
    ind/=2;
    while(ind!=0) {
        minimum[ind] = min(minimum[ind*2], minimum[ind*2+1]);
        ind/=2;
    }
}

ull query (int indL, int indR) {
    ull ans = inf;
    indL = getLeaf(indL);
    indR = getLeaf(indR);
    if (indL == indR)
        return minimum[indL];
    ans = min(minimum[indL], minimum[indR]);
    indL += (indL%2);
    indL /= 2;
    indR -= !(indR%2);
    indR/=2;
    while (indL < indR) {
        ans = min(ans,min(minimum[indL], minimum[indR]));
        indL += (indL%2);
        indL /= 2;
        indR -= !(indR%2);
        indR/=2;
    }
    return ans;
}
int main() {
    cin >> N >> A >> B;
    for (int i = 0; i < N; ++i) {
        cin >> pl[i].S >> pl[i].E >> pl[i].C;
        if (pl[i].E>B) pl[i].E = B;
    }
    sort(pl+0, pl+N, comp);
    for (int i = 1; i < 4*MAX_M; ++i) {
        minimum[i] = inf;

    }
    for (int i = 0; i < N; ++i) {
        if (pl[i].E<A) continue;
        /*for (int i = 1; i < 4*MAX_M; ++i) {
            cout << minimum[i]<< " ";
        }
        cout << pl[i].S<< " "<< pl[i].E << " " << pl[i].C << " " << query(pl[i].S-1,pl[i].E-1) << "\n";*/
        if(pl[i].S>A)update(pl[i].E, pl[i].C+query(pl[i].S-1,pl[i].E-1));
        else update(pl[i].E, pl[i].C);

    }
    if (minimum[getLeaf(B)]==inf){
        while(true)
            cout << -1;
        cout << "Impossible\n";
        return 0;
    }
    /*for (int i = 1; i < 4*MAX_M; ++i) {
        cout << minimum[i]<< " ";
    }*/
    cout << minimum[getLeaf(B)] << "\n";
    return 0;
}
/*
5
5 15
11 15 8
1 6 23
6 12 13
7 16 35
3 5 10

11
5 15
14 16 12
13 14 11
12 13 10
11 12 9
10 11 8
9 10 7
8 9 6
7 8 5
6 7 4
5 6 3
2 3 2

*/
