#include<algorithm>
#include<iostream>
using namespace std;

const int MAXN=500000;
const long long INF=1000000000000000000;

struct plan
{
    int s,e,c;
};

plan a[MAXN+5];

long long dp[MAXN+5];

bool cmp(plan x,plan y)
{
    return x.e<y.e;
}

/*int rec(int idx)
{
    if(a[idx].e>=B) return a[idx].c;
    int x=1000000000;
    for(int i=idx+1; i<N and a[i].s-1<=a[idx].e; i++)
        x=min(x,rec(i));
    if(x==1000000000) return x;
    return a[idx].c+x;
}*/

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int N,A,B;
    cin >> N >> A >> B;

    //int idx=0;
    for(int i=0; i<N; i++)
    {
        cin >> a[i].s >> a[i].e >> a[i].c;
        //if(a[idx].e<A or a[idx].s>B) idx--;
        //idx++;
    }

    //N=idx;

    sort(a,a+N,cmp);

    dp[N-1]=a[N-1].c;
    if(a[N-1].e<B or a[N-1].s>B) dp[N-1]=INF;
    for(int i=N-2; i>=0; i--)
    {
        dp[i]=INF;
        if(a[i].e>=B) dp[i]=a[i].c;
        for(int j=i+1; j<N and a[i].e+1>=a[j].s; j++)
            dp[i]=min(dp[i],dp[j]+a[i].c);
    }

    long long ans=INF;
    for(int i=0; i<N; i++)
        if(a[i].s<=A) ans=min(ans,dp[i]);

    if(ans==INF) cout << "Impossible" << endl;
    else cout << ans << endl;

    /*int i=0;
    int ans=1000000000;
    while(a[i].s<=A and i<N)
    {
        int x=rec(i);
        ans=min(ans,x);
        i++;
    }

    if(ans==1000000000) cout << "Impossible" << endl;
    else cout << ans << endl;*/

    return 0;
}
