#include <bits/stdc++.h>
using namespace std;
#define sz(x) (int)x.size()
#define pb(x) push_back(x)
#define print(x) cout << #x << " = " << x << "\n";

const int MAX_N = 5e5 + 10, MAX_M = 1e7 + 10;
long long dp[MAX_N];
long long ans[MAX_N];
struct Plan {
    int a, b, c, ind;
    bool operator <(Plan &other) {
        if(a == other.a) {
            if(b == other.b) {
                return c < other.c;
            }
            return b < other.b;
        }
        return a < other.a;
    }
};
Plan plan[MAX_N];
long long a, b;
long long n;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n;
    cin >> a >> b;
    for(int i = 0; i < n; i ++) {
        cin >> plan[i].a >> plan[i].b >> plan[i].c;
    }
    sort(plan, plan + n);
    for(int i = 0; i < n; i ++) {
        plan[i].ind = i;
    }
    fill_n(dp, n, MAX_M);
    for(int i = 0; i < n; i ++) {
        if(plan[i].a <= a && plan[i].b >= a) {
            ans[i] = 0;
        }
    }
    for(int i = 0; i < n; i ++) {
        if(dp[i] == -1) {
            continue;
        }
        for(int j = i + 1; j < n; j ++) {
            if(plan[j].a <= plan[i].b && plan[j].a > plan[i].a && plan[j].b > plan[i].b + 1) {
                dp[j] = min(dp[i] + plan[j].c, dp[j]);
            }
        }
    }
    long long ans = MAX_M;
    for(int i = 0; i < n; i ++) {
        if(plan[i].b >= b && dp[i] != -1) {
            ans = min(ans, dp[i]);
        }
    }
    if(ans == MAX_M) {
        cout << "Impossible";
    } else {
        cout << ans;
    }
    return 0;
}
