#include <iostream>
#include <algorithm>

long long ans[(int)1e8 + 10];

struct plan {
    int from, to, prize;

    bool operator< (plan other)
    {
        if(to == other.to)
        {
            if(from == other.from)
            {
                return prize < other.prize;
            }
            return from < other.from;
        }
        return to < other.to;
    }
};

plan plans[(int)(5 * 1e5)];

int main()
{
    std::cin.tie(NULL);
    std::ios_base::sync_with_stdio(false);

    int n, a, b;
    std::cin >> n >> a >> b;

    for(int i = 0; i < n; ++ i)
    {
        std::cin >> plans[i].from >> plans[i].to >> plans[i].prize;
    }

    std::sort(plans, plans + n);

    int dokade = 0;

    for(int p = a; p <= b; ++ p)
    {
        while(plans[dokade].to < p)
        {
            dokade ++;
        }
        long long i = dokade, otg;

        while(i < n)
        {
            if(plans[i].from <= p)
            {
                otg = ans[plans[i].from - 1] + plans[i].prize;
            }
            if(otg < ans[p] || ans[p] == 0)
            {
                ans[p] = otg;
            }
            ++ i;
        }
        //std::cout << ans[p] << ' ';
        if(ans[p] == 0)
        {
            std::cout << "Impossible\n";
            return 0;
        }
    }

    std::cout << ans[b] << '\n';

    return 0;
}
/*
5
5 15
11 15 8
1 6 23
6 12 13
7 16 9
3 5 10
*/
