#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
using namespace std;
struct plan{
    int s;
    int e;
    int price;
};
struct link{
    int target;
    int toll;
};
plan plans[500010];
vector <link> graph[500000];         //0  'a',  1  'b'
unsigned long long used[500010];
int n, a, b;
bool cmp(plan x, plan y)
{
    if (x.s<y.s) return true;
    return false;
}
void init()
{
    cin>>n;
    cin>>a>>b;
    for (int i=2; i<n+2; i++){
        cin>>plans[i].s>>plans[i].e>>plans[i].price;
        plans[i].e++;
    }
    sort(plans+2, plans+(n+2), cmp);
}
void buildGraph()
{
    link temp;
    for (int i=2; i<n+2; i++){
        if (a>=plans[i].s and a<=plans[i].e){
            temp.target=i;
            temp.toll=plans[i].price;
            graph[0].push_back(temp);
            temp.target=0;
            temp.toll=0;
            graph[i].push_back(temp);
            //cout<<"katran: "<<i<<endl;
        }
        if (b>=plans[i].s and b<=plans[i].e){
            temp.target=i;
            temp.toll=plans[i].price;
            graph[1].push_back(temp);
            temp.target=1;
            temp.toll=0;
            graph[i].push_back(temp);
            //cout<<"petrol: "<<i<<endl;
        }
    }
    for (int i=2; i<n+2; i++){
        for (int j=i+1; j<n+2; j++){
            if ((plans[j].s>=plans[i].s and plans[j].s<=plans[i].e) or (plans[j].e>=plans[i].s and plans[j].e<=plans[i].e)){
                temp.target=j;
                temp.toll=plans[j].price;
                graph[i].push_back(temp);
                temp.target=i;
                temp.toll=plans[i].price;
                graph[j].push_back(temp);
            }
        }
    }
}
unsigned long long djikstra()
{
    queue <int> q;
    int qFront;
    for (int i=0; i<n+2; i++){
        used[i]=1<<32-1;
    }
    q.push(0);
    used[0]=0;
    while (q.size()!=0){
        qFront=q.front();
        //cout<<"!"<<qFront<<endl;
        for (int i=0; i<graph[qFront].size(); i++){
            if (graph[qFront][i].toll+used[qFront]<used[graph[qFront][i].target]){
                used[graph[qFront][i].target]=graph[qFront][i].toll+used[qFront];
                q.push(graph[qFront][i].target);
                //cout<<qFront<<" pushed "<<graph[qFront][i].target<<endl;
            }
        }
        q.pop();
    }
    return used[1];
}
int main()
{
    init();
    buildGraph();
    /*for (int i=0; i<n+2; i++){
        cout<<i<<" -> ";
        for (int j=0; j<graph[i].size(); j++){
            cout<<"to "<<graph[i][j].target<<" for "<<graph[i][j].toll<<"; ";
        }
        cout<<endl;
    }*/
    cout<<djikstra()<<endl;
    //cout<<used[3]<<endl;

    return 0;
}
/**
5
5 15
11 15 8
1 6 23
6 12 13
7 16 35
3 5 10
*/
